FROM ubuntu:20.04

LABEL maintainer="Max Audron <audron@cocaine.farm>"

ARG SERVER_TOOLS_VERSION=v1.6.51

ENV ARK_SESSION_NAME="A Docker Powered Ark Server" \
	ARK_SERVER_MAP="TheIsland" \
	ARK_RCON_ENABLED="True" \
	ARK_SERVER_PASSWORD="" \
	ARK_SERVER_ADMIN_PASSWORD="" \
	ARK_WARN_ON_STOP="" \
	ARK_MAX_PLAYERS=70 \
	ARK_MOD_IDS="" \
	ARK_TOTAL_CONVERSION_MOD="" \
	ARK_MAP_MOD="" \
	ARK_LOG_DIRECTORY="/data/log" \
	ARK_UPDATE_ON_START="false" \
	ARK_BACKUP_PRE_UPDATE="false" \
	ARK_MAX_BACKUP_SIZE_MIB="500" \
	ARK_SERVER_ROOT="/data" \
	ARK_PORT=7777 \
	ARK_QUERY_PORT=27015 \
	ARK_RCON_PORT=32330

ENV SERVER_TOOLS_VERSION=$SERVER_TOOLS_VERSION

RUN dpkg --add-architecture i386 && apt-get update && \
	DEBIAN_FRONTEND=noninteractive apt-get install -yq \
		perl-modules curl lsof libc6-i386 lib32gcc1 bzip2 \
	>=bash-4.0 >=coreutils-7.6 findutils perl rsync sed tar git gettext

RUN echo steam steam/question select "I AGREE" | debconf-set-selections && \
	echo steam steam/license note '' | debconf-set-selections && \
	DEBIAN_FRONTEND=noninteractive apt-get install -yq steamcmd

RUN apt-get clean && rm -rf /var/lib/apt/lists/

RUN useradd -m -s /bin/bash --uid 1000 steam

WORKDIR /work
RUN curl -sqL https://github.com/FezVrasta/ark-server-tools/archive/${SERVER_TOOLS_VERSION}.tar.gz | tar zxvf - && \
	cd "/work/ark-server-tools-${SERVER_TOOLS_VERSION##v}/tools" && \
	./install.sh steam

COPY root/ /

RUN mkdir ${ARK_SERVER_ROOT} && chown steam -R ${ARK_SERVER_ROOT} /etc/arkmanager

# EXPOSE ${ARK_PORT} ${ARK_RCON_PORT} ${ARK_QUERY_PORT}
# Add UDP
# EXPOSE ${ARK_PORT}/udp ${ARK_QUERY_PORT}/udp

VOLUME ${ARK_SERVER_ROOT}

USER steam 
WORKDIR ${ARK_SERVER_ROOT}
ENTRYPOINT ["/entrypoint.sh"]
